﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.JavaScript.Web;
using System.Web.Script.Serialization;
using System.Collections;
using System.Web.Script.Services;

namespace WebApplication1
{
    public partial class WebForm2 : System.Web.UI.Page
    {
        public object data;

        private List<Orders> order = new List<Orders>();
        protected void Page_Load(object sender, EventArgs e)
        {
            BindDataSource();
            bindcountry();
            Session["DialogDataSource"] = order;
        }

        private void BindDataSource()
        {
            if ((List<Orders>)Session["DialogDataSource"] == null)
            {
                int orderId = 10643;
                int empId = 0;
                for (int i = 1; i < 9; i++)
                {
                    order.Add(new Orders(orderId + 1, "Alfreds Futterkiste ", "Germany"));
                    order.Add(new Orders(orderId + 2, "Ana Trujillo Emparedados y helados", "Mexico"));
                    order.Add(new Orders(orderId + 3, "Antonio Moreno Taquería", "Mexico"));
                    order.Add(new Orders(orderId + 4, "Around the Horn", "UK"));
                    order.Add(new Orders(orderId + 5, "Berglunds snabbköp", "Sweden"));
                    order.Add(new Orders(orderId + 6, "Blondel père et fils", "France"));
                    orderId += 6;
                    empId += 6;
                }
            }
            else
            {
                order = (List<Orders>)Session["DialogDataSource"];
            }
            this.OrdersGrid.DataSource = order;
            this.OrdersGrid.DataBind();
        }


        private void bindcountry()
        {


            List<Countries> c = new List<Countries>();
            c.Add(new Countries { text = "Austria", ID = "100001" });
            c.Add(new Countries { text = "Australia", ID = "20002" });
            c.Add(new Countries { text = "Bangladesh", ID = "300003" });


            this.ShipCountry.DataSource = c;
            ShipCountry.DataTextField = "text";
            ShipCountry.DataUniqueKeyField = "ID";
            ShipCountry.DataBind();



        }

        [Serializable]
        class Countries
        {
            public string text;
            public string ID;
        }
        [WebMethod]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public static object ButtonQueries(string grid)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable gridData = (IEnumerable)serializer.Deserialize(grid, typeof(IEnumerable)); //Retrieves current set of records 
            return new { result = gridData };
        } 


       
        protected void EditEvents_ServerEditRow(object sender, GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void EditEvents_ServerAddRow(object sender, GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void EditEvents_ServerDeleteRow(object sender, GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void EditAction(string eventType, object record)
        {
            List<Orders> data = Session["DialogDataSource"] as List<Orders>;
            Dictionary<string, object> KeyVal = record as Dictionary<string, object>;
            if (eventType == "endEdit")
            {
                Orders value = new Orders();
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {

                    if (keyval.Key == "OrderID")
                    {
                        value = data.Where(d => d.OrderID == (int)keyval.Value).FirstOrDefault();
                        value.OrderID = Convert.ToInt32(keyval.Value);
                    }

                    else if (keyval.Key == "ShipCountry")
                        value.ShipCountry = Convert.ToString(keyval.Value);
                    else if (keyval.Key == "ShipName")
                        value.ShipName = Convert.ToString(keyval.Value);
                }
            }

            else if (eventType == "endAdd")
            {
                Orders newRecord = new Orders();
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {

                    if (keyval.Key == "OrderID")
                        newRecord.OrderID = Convert.ToInt32(keyval.Value);

                    else if (keyval.Key == "ShipCountry")
                        newRecord.ShipCountry = Convert.ToString(keyval.Value);
                    else if (keyval.Key == "ShipName")
                        newRecord.ShipName = Convert.ToString(keyval.Value);

                }
                data.Insert(0, newRecord);
            }

            else if (eventType == "endDelete")
            {
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {
                    if (keyval.Key == "OrderID")
                    {
                        Orders value = data.Where(d => d.OrderID == (int)keyval.Value).FirstOrDefault();
                        data.Remove(value);
                    }
                }
            }
            Session["DialogDataSource"] = data;
            this.OrdersGrid.DataSource = data;
            this.OrdersGrid.DataBind();
        }

        [Serializable]
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(int orderId, string shipName, string shipCountry)
            {
                this.OrderID = orderId;

                this.ShipCountry = shipCountry;
                this.ShipName = shipName;
            }
            public int OrderID { get; set; }

            public string ShipCountry { get; set; }
            public string ShipName { get; set; }
        }


    }
}